<template>
  <div class="main CourseInfo">
    <div class="courseScore">
      <h3>
        <i class="el-icon-chat-dot-round" style="color: rgb(153, 204, 255)"></i>
        课程问答
      </h3>
    </div>
    <div class="commentsBlock">
      <el-row>
        <el-col :span="6">
          <el-input
            placeholder="输入搜索内容"
            v-model="search_input"
            clearable
            prefix-icon="el-icon-search"
          ></el-input>
        </el-col>
        <el-col :span="4">
          <el-button v-if='!search_status' v-on:click='EnterSearch()' type="primary" plain style="margin: 0px 0px 0px 10px">搜索</el-button>
          <el-button v-else v-on:click='GetQuestionList()' type="primary" plain style="margin: 0px 0px 0px 10px">返回</el-button>
        </el-col>
        <el-col :span="2" :offset="10">
          <el-select v-model="tml_option" style="width: 150px" @change='TmlChange'>
            <el-option
              v-for="item in tml_options"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            ></el-option>
          </el-select>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="24">
          <el-divider></el-divider>
        </el-col>
      </el-row>

      <el-row v-for="item in post_data" :key="item.post_id" class="QandA">
        <el-col :span="24">
          <div>
            <div class="inline" style="width: 90%; margin: 5px 0px">
              <p v-on:click="EnterPost(item.post_id)" class="text post-head">
                {{ item.post_head }}
              </p>
              <p class="text post-content">{{ item.post_content }}</p>
              <p class="text post-time" style="margin: 30px 0px 0px 0px">
                {{ item.post_time + (item.post_stick_state?'   置顶':'') }}
              </p>
            </div>
            <div
              class="inline"
              style="width: 10%; margin: 10px 0px; text-align: center"
            >
              <el-avatar :size="50" :src='item.post_avatar'></el-avatar>
              <p class="post-username">{{ item.post_user_name }}</p>
              <div class="post-info" style="margin: 24px 0px 0px 0px">
                <i class="el-icon-chat-line-round"></i>
                <span>{{ item.post_reply_count }}</span>
                <i
                  v-on:click="LikeQuestion(post_data.indexOf(item),!item.post_like_state)"
                  class="el-icon-magic-stick like-icon"
                  v-bind:class="{liked: item.post_like_state}"
                  style="margin: 0px 0px 0px 10px"
                ></i>
                <span>{{ item.post_like_count }}</span>
              </div>
            </div>
          </div>
        </el-col>
      </el-row>
    </div>

    <el-row>
      <el-col :span="20" :offset="2" type="flex" justify="center">
        <el-pagination background layout="prev, pager, next" :page-size='page_size' :total='post_count' @current-change='PageChange' ></el-pagination>
      </el-col>
    </el-row>

    <el-row>
       <el-col :span="24">
        <el-divider></el-divider>
      </el-col>
    </el-row>

    <el-row>
      <el-button v-on:click='dialog_post_vis=true' type="success" plain style="margin:30px 0px 0px 0px;">发起提问</el-button>
    </el-row>

    <el-dialog  title='输入问题' :visible.sync='dialog_post_vis' width='50%'>
      <el-row>
          <el-col :span="10">
            <el-input placeholder="输入问题标题" v-model="question_head_input" 
            maxlength="30" clearable style="margin:0px 0px 0px 0px;"></el-input>
          </el-col>
      </el-row>
      <el-row style="margin:20px 0px 0px 0px;">
          <el-col :span="20">
            <div style='border: 1px solid #ccc;'>
              <Toolbar :editor='editor' :mode='editor_mode' :defaultConfig='toolbar_config'
              style='border-bottom: 1px solid #ccc;'/>
              <Editor v-model='question_content_input' :mode='editor_mode' @onCreated='EditorCreated' :defaultConfig='editor_config'
              style='height:300px;overflow-y:hidden;text-align:left;'/>
            </div>
          </el-col>
      </el-row>
      <el-row>
          <el-col :span="8" :offset="16">
            <el-button v-on:click='AddQuestion();dialog_post_vis=false' type="success" plain style="margin:20px 0px 0px 0px;">确认提交</el-button>
            <el-button v-on:click='dialog_post_vis=false' type="danger" plain style="margin:20px 0px 0px 20px;">取消</el-button>
          </el-col>
      </el-row>
    </el-dialog>
  </div>
</template>

<script>

import { Editor,Toolbar } from '@wangeditor/editor-for-vue';

export default {
  name: 'CourseForum',
  props:['cid'],
  data() {
    return {
      course_id: this.cid,

      tml_options: [{
        value: 0,
        label: '最新回复'
      },{
        value: 1,
        label: '最新发布'
      },{
        value: 2,
        label: '最早发布'
      }],
      tml_option: 0,

      search_input: '',
      search_status: false,

      question_head_input: '',
      question_content_input: '',
      question_image_list: [],

      post_data: [],
      post_count: 1,
      
      page_size: 5,
      cur_page: 1,

      dialog_post_vis: false, 

      editor: null,
      editor_mode: 'simple',
      editor_config: { placeholder:'输入问题内容',maxLength:500,scroll:true,
        MENU_CONF:{ uploadImage:{ point:this, server: 'http://localhost:3000/api/upload/upload-image', fieldName:'images', 
          onSuccess(file,res){
            //
          }, }, }, },
      toolbar_config: { excludeKeys:[ 'insertVideo','fullScreen', ], },
    };
  },
  methods:{
    getAvatar(index,user_id){
      this.$axios.get('/api/user/info',{
        params:{
          email : user_id + '@tongji.edu.cn',
        }
      })
        .then((response)=>{
          this.post_data[index].post_avatar = response.data.data.avatar;
        })
        .catch((error)=>{
          console.log(error);
        });
    },
    getTime(timestamp){
      var date = new Date(timestamp);
      return (date.getFullYear()+'-'+date.getMonth()+'-'+date.getDate());
    },
    EnterPost:function(post_id){
      this.$emit('enterpost',post_id);
    },
    EnterSearch:function(){
      this.cur_page = 1;
      this.SearchContent();
    },
    TmlChange:function(){
      if(!this.search_status)
        this.GetQuestionList();
      else
        this.SearchContent();
    },
    PageChange:function(page){
      this.cur_page = page;
      if(!this.search_status)
        this.GetQuestionList();
      else
        this.SearchContent();
    },
    EditorCreated(editor){
      this.editor = Object.seal(editor);
    },


    GetQuestionList:function(){
      this.search_status = false;
      this.$axios.get('/api/forum/get-question',{
        params:{
          user_id : this.$store.getters.getEmail.slice(0,7),
          course_id : this.course_id,
          idx_up : (this.cur_page-1)*this.page_size,
          idx_low : this.cur_page*this.page_size,
          idx_type : this.tml_option,
        }
      })
        .then((response)=>{
          this.search_status = false;
          this.post_count = response.data.question_count;
          this.post_data = [];
          let i=0;
          response.data.question_list.forEach(element => {
            var temp = {
              post_id: element.question_id,
              post_head: element.question_head,
              post_content: element.thumbnail,
              post_time: this.getTime(element.reply_timestamp),
              post_user_id: element.user_id,
              post_user_name: element.user_id,
              post_reply_count: element.reply_count,
              post_like_count: element.like_count,
              post_like_state: element.like_state,
              post_stick_state: element.stick_state,
              post_avatar: '',
            };
            this.post_data.push(temp);
            this.getAvatar(i,element.user_id);
            i+=1;
          });
          this.$forceUpdate();
        })
        .catch((error)=>{
          console.log(error);
        });
    },
    SearchContent:function(){
      this.$axios.get('/api/forum/search-content',{
        params:{
          user_id : this.$store.getters.getEmail.slice(0,7),
          course_id : this.course_id,
          search_content : this.search_input,
          idx_up : (this.cur_page-1)*this.page_size,
          idx_low : this.cur_page*this.page_size,
          idx_type : this.tml_option,
        }
      })
        .then((response)=>{
          this.search_status = true;
          this.post_count = response.data.question_count;
          this.post_data = [];
          let i=0;
          response.data.question_list.forEach(element => {
            var temp = {
              post_id: element.question_id,
              post_head: element.question_head,
              post_content: element.thumbnail,
              post_time: this.getTime(element.reply_timestamp),
              post_user_id: element.user_id,
              post_user_name: element.user_id,
              post_reply_count: element.reply_count,
              post_like_count: element.like_count,
              post_like_state: element.like_state,
              post_stick_state: element.stick_state,
              post_avatar: '',
            };
            this.post_data.push(temp);
            this.getAvatar(i,element.user_id);
            i+=1;
          });
          this.$forceUpdate();
        })
        .catch((error)=>{
          console.log(error);
        });
    },
    LikeQuestion:function(index, type){
      let post_id = this.post_data[index].post_id;
      this.$axios.post('/api/forum/like-question',{
        question_id : post_id,
        user_id : this.$store.getters.getEmail.slice(0,7),
        like_type : type?1:0,
      })
        .then((response)=>{
          this.$set(this.post_data[index], 'post_like_state', response.data.like_state);
          this.$set(this.post_data[index], 'post_like_count', this.post_data[index].post_like_count + (type?1:(-1)));
          //这样写合适吗
        })
        .catch((error)=>{
          console.log(error);
        });
    },
    AddQuestion:function(){
      let thumbnail_content = this.editor.getText().slice(0,19);
      if(this.question_head_input.length>=2 && thumbnail_content.length>=5){
        this.$axios.post('/api/forum/add-question',{
          course_id : this.course_id,
          question_head : this.question_head_input,
          question_content : this.question_content_input,
          user_id : this.$store.getters.getEmail.slice(0,7),
          question_stamp : 14000,
          thumbnail : thumbnail_content,
          image_list : this.question_image_list,
        })
          .then((response)=>{
            this.question_head_input='';
            this.question_content_input='';
            this.question_image_list=[];
            this.GetQuestionList();
          })
          .catch((error)=>{
            console.log(error);
          });
      }
      else if(this.question_head_input.length<2){
        this.$message('标题长度至少应为2');
      }
      else if(thumbnail_content.length<5){
        this.$message('回复长度至少应为5');
      }
    },
  },

  computed: {

  },

  components: {
    Editor,
    Toolbar,
  },

  created: function(){
    this.GetQuestionList();
  },
  beforeDestroy(){
    const editor = this.editor;
    if(editor == null)
      return;
    editor.destroy();
  },
};
</script>

<style src='@wangeditor/editor/dist/css/style.css'></style>
<style scoped>
.img{
  max-height: 100% ;
  max-width: 100% ;
}
.main {
  margin-left: 20px;
  margin-right: 20px;
  background: #fff;
  border-radius: 12px;
}
.CourseInfo {
  background: #f8f8f8;
}
.commentsBlock {
  margin: 20px 50px 20px 50px;
  text-align: left;
}
.courseScore {
  margin: 30px 30px 20px 30px;
  text-align: left;
}
.msg-block {
  min-height: 140px;
}
.inline {
  display: inline;
  float: left;
}
.QandA {
  margin: 5px 0px 5px 0px;
  padding: 10px 20px 10px 50px;
  font-size: 14px;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.12), 0 0 6px rgba(0, 0, 0, 0.04);
}
.post-head {
  font-weight: bold;
  font-size: 18px;
  cursor: pointer;
}
.post-time {
  color: #888;
  font-size: 12px;
}
.like-icon {
  cursor: pointer;
}
.liked {
  color: red;
}
</style>
